//+------------------------------------------------------------------+
//|                                                 SHI_SilverEx.mq4 |
//|                                                          Kalenzo |
//|                                      
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "simone@konto.pl"

extern int MagicNumber = 980890;
extern double Lots = 1000;
extern double TakeProfit = 175;
extern double StopLoss = 100;
extern bool Allow_Two_Dots = true;
extern bool Allow_One_Dot = true;
extern bool UseReversal_to_Close = true;
extern bool UseSandwichTrailingStop = false;
extern bool UseBreakEven = false;
extern double BreakEven = 50;
extern bool Use_MA_Filter = false;
extern int  MA_Filter_Period = 50;
extern int  MA_Filter_Mode = MODE_SMMA;
extern string s="Use numbers below for MA_Filter_Mode";
extern int MODE_simple = MODE_SMA;
extern int MODE_ema = MODE_EMA;
extern int MODE_smma = MODE_SMMA;
extern int MODE_lwma = MODE_LWMA;

int buybars,sellbars,sells,buys;
double DigitsMulti,adj,tp,sl,buy1,buy2,buy3,sell1,sell2,sell3;
string cmt;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
      if(Digits==3||Digits==5)DigitsMulti=10;else DigitsMulti=1;
      adj=Point*DigitsMulti;
      StopLoss*=adj;
      TakeProfit*=adj;
      BreakEven*=adj;
      Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
      Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
      if(buybars == 0)buybars = Bars;
      if(sellbars == 0)sellbars = Bars;
      
      
      buy1=EMPTY_VALUE;
      buy2=EMPTY_VALUE; 
      buy3=EMPTY_VALUE; 
      sell1=EMPTY_VALUE; 
      sell2=EMPTY_VALUE; 
      sell3=EMPTY_VALUE;
      
      int ticket = 0;

       buy1 = iCustom(Symbol(),0,"SHI_SilverTrendSig_Mod2",0,1);
       buy2 = iCustom(Symbol(),0,"SHI_SilverTrendSig_Mod2",0,2);
       if(!Allow_Two_Dots)buy3 = iCustom(Symbol(),0,"SHI_SilverTrendSig_Mod2",0,3);
      
       sell1 = iCustom(Symbol(),0,"SHI_SilverTrendSig_Mod2",1,1);
       sell2 = iCustom(Symbol(),0,"SHI_SilverTrendSig_Mod2",1,2);
       if(!Allow_Two_Dots)sell3 = iCustom(Symbol(),0,"SHI_SilverTrendSig_Mod2",1,3);
      
      SaveProfitLoss();
      Comment(
         Use_MA_Filter
         +" up "+(iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,1)> iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,2))
         +" down "+(iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,1)< iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,2))
         );   
         
      if
      (
         Bars > buybars 
         &&
         ((Use_MA_Filter && iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,1)> iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,2))||!Use_MA_Filter)
         &&
         (
            (
               buy1!=EMPTY_VALUE
               && buy2!=EMPTY_VALUE 
               && buy3!=EMPTY_VALUE 
               && buy1>buy2 && buy2>buy3
            )
            ||
            (
               Allow_Two_Dots
               && buy1!=EMPTY_VALUE
               && buy2!=EMPTY_VALUE 
               //&& buy3!=EMPTY_VALUE 
               && buy1>buy2// && buy2>buy3
            )
            ||
            (
               Allow_One_Dot
               && buy1!=EMPTY_VALUE
               && buy2==EMPTY_VALUE
            )
         )
      )
      {
         buybars = Bars;
         sl = NormalizeDouble(Ask-StopLoss,Digits);
         tp = NormalizeDouble(Ask+TakeProfit,Digits);
         
         ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sl,tp,WindowExpertName(),MagicNumber,0,CLR_NONE);
         if(ticket<0)
         {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
         }

      }
      else 
      if
      (
         Bars > sellbars 
         &&
         ((Use_MA_Filter && iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,1)< iMA(Symbol(),0,MA_Filter_Period,0,MA_Filter_Mode,0,2))||!Use_MA_Filter)
         &&
         (
            (
               sell1!=EMPTY_VALUE
               && sell2!=EMPTY_VALUE 
               && sell3!=EMPTY_VALUE 
               && sell1<sell2 && sell2<sell3
            )
            ||
            (
               Allow_Two_Dots
               && sell1!=EMPTY_VALUE
               && sell2!=EMPTY_VALUE 
               //&& sell3!=EMPTY_VALUE 
               && sell1<sell2// && sell2<sell3
            )
            ||
            (
               Allow_One_Dot
               && sell1!=EMPTY_VALUE
               && sell2==EMPTY_VALUE
            )
         )
      )
      {
         sellbars = Bars;
         sl = NormalizeDouble(Bid+StopLoss,Digits);
         tp = NormalizeDouble(Bid-TakeProfit,Digits);
         
         ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sl,tp,WindowExpertName(),MagicNumber,0,CLR_NONE);
         if(ticket<0)
         {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
         }

      }
   return(0);
  }
//+------------------------------------------------------------------+

void SaveProfitLoss()
{
   buys=0;
   sells=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
         if(OrderProfit()>0)
         {
            if(OrderType()==OP_BUY)buys++;
            if(OrderType()==OP_SELL)sells++;
            //sandwich trailing stop settings
            if(UseSandwichTrailingStop && OrderType()==OP_BUY && OrderStopLoss()<Bid-(OrderTakeProfit()-Bid))
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(OrderTakeProfit()-Bid),OrderTakeProfit(),0,CLR_NONE);
            }
            if(UseSandwichTrailingStop && OrderType()==OP_SELL && OrderStopLoss()>Ask+(Ask-OrderTakeProfit()))
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(Ask-OrderTakeProfit()),OrderTakeProfit(),0,CLR_NONE);
            }
            
            //breakeven settings
            if(UseBreakEven && OrderType()==OP_BUY && OrderStopLoss()<Bid-BreakEven)
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
            }
            if(UseBreakEven && OrderType()==OP_SELL && OrderStopLoss()>Ask+BreakEven)
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
            }
         }
         if(UseReversal_to_Close && buys>0 && sell1!=EMPTY_VALUE)OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
         if(UseReversal_to_Close && sells>0 && buy1!=EMPTY_VALUE)OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
      }
      Comment(cmt);
   }
}